<?php namespace App\Controllers\Configuracion;


use App\Models\Usuarios\GroupModel;
use App\Models\Usuarios\GroupsUsersModel;
use App\Models\Usuarios\PermisosModel;

class Group extends \App\Controllers\GoBaseController
{
    use \CodeIgniter\API\ResponseTrait;

    protected static $primaryModelName = 'App\Models\Usuarios\GroupModel';
    protected $modelName = GroupModel::class;

    protected static $singularObjectNameCc = 'userGroup';
    protected static $singularObjectName = 'Group';
    protected static $pluralObjectName = 'Groups';
    protected static $controllerSlug = 'groups';

    static $viewPath = '';

    protected $indexRoute = 'userGroupList';

    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        self::$viewPath = getenv('theme.path') . 'form/group/';

        // Breadcrumbs
        $this->viewData['breadcrumb'] = [
            ['title' => "Home", 'route' => "javascript:void(0);", 'active' => false],
            ['title' => lang("App.menu_permission_group"), 'route' => route_to("userGroupList"), 'active' => true]
        ];

        parent::initController($request, $response, $logger);

    }

    public function index()
    {
        $this->viewData['usingClientSideDataTable'] = true;
        $this->viewData['pageSubTitle'] = lang('Basic.global.ManageAllRecords', [lang('Groups.group')]);
        // IMN
        $this->viewData['model'] = $this->model;

        parent::index();
    }

    public function add()
    {

        if ($this->request->getPost()) :

            $postData = $this->request->getPost();

            $temp_data['id'] = $groupEntity->id;
            $temp_data['title'] = $postData['title'];
            $temp_data['description'] = $postData['description'];

            // Clear not rules fields
            unset($postData['safekat_token']);
            unset($postData['id']);
            unset($postData['title']);
            unset($postData['description']);
            unset($postData['save']);
            unset($postData['selectAll']);

            $rules_access = [];
            foreach ($postData as $key => $value) {
                $exp = explode('_', $key);
                if (!isset($rules_access[$exp[0]])) {
                    $rules_access[$exp[0]] = [];
                }
                array_push($rules_access[$exp[0]], str_replace($exp[0] . '_', '', $key));
            }

            $temp_data['rules'] = json_encode($rules_access ?? '{}');

            $sanitizedData = $this->sanitized($temp_data, true);

            $noException = true;
            if ($successfulResult = $this->canValidate()) :

                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult) :

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->viewData['successMessage'] = $message;
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['group'] = isset($sanitizedData) ? new GroupModel($sanitizedData) : new GroupModel();
        $this->viewData['permisos'] = (new PermisosModel())->find();
        $this->viewData['formAction'] = route_to('createGroup');

        return $this->displayForm(__METHOD__);
    }


    public function edit($requestedId = null)
    {

        helper('general');

        if ($requestedId == null) :
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $groupEntity = $this->model->find($id);

        if ($groupEntity == false) :
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('Group.userGroup')), $id]);
            return $this->redirect2listView('errorMessage', $message);
        endif;

        if ($this->request->getPost()) :

            $postData = $this->request->getPost();

            $temp_data['id'] = $groupEntity->id;
            $temp_data['title'] = $postData['title'];
            $temp_data['description'] = $postData['description'];

            // Clear not rules fields
            unset($postData['safekat_token']);
            unset($postData['id']);
            unset($postData['title']);
            unset($postData['description']);
            unset($postData['save']);
            unset($postData['selectAll']);

            $rules_access = [];
            foreach ($postData as $key => $value) {
                $exp = explode('_', $key);
                if (!isset($rules_access[$exp[0]])) {
                    $rules_access[$exp[0]] = [];
                }
                array_push($rules_access[$exp[0]], str_replace($exp[0] . '_', '', $key));
            }

            $temp_data['rules'] = json_encode($rules_access ?? '{}');

            $sanitizedData = $this->sanitized($temp_data, true);

            $noException = true;
            if ($successfulResult = $this->canValidate()) :

                if ($this->canValidate()) :
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('Group.userGroup'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $groupEntity->fill($sanitizedData);

                $thenRedirect = false;
            endif;

            if ($noException && $successfulResult) :

                // IMN hacer las configuraciones hard coded
                helper('rbac');
                generate_php_roles_constant();
                generate_php_permissions_constant();
                generate_php_permissions_matrix_constant();

                $id = $groupEntity->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect) :
                    if (!empty($this->indexRoute)) :
                        return redirect()->to(route_to($this->indexRoute))->with('successMessage', $message);
                    else:
                        return $this->redirect2listView('successMessage', $message);
                    endif;
                else:
                    $this->viewData['successMessage'] = $message;
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['group'] = $groupEntity;
        $this->viewData['permisos'] = (new PermisosModel())->find();
        $this->viewData['formAction'] = route_to('updateGroup', $id);

        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', nombre', 'nombre', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->nombre = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'nombre'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }
}
